#pragma once

#include <SFML/Graphics.hpp>

class Circle: public sf::Drawable
{
	public:
		Circle() = delete;
		Circle(sf::Color color, float scale);
		virtual ~Circle();
		void setTexture(sf::Texture& texture);
		void setPosition(sf::Vector2f position);
		void setPosition(float x, float y);
		void setRotation(float rotation);
		void rotate(float rotation);
		void setSize(unsigned size);
		void update(sf::Time delta);
		void show();
		
	private:
		virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const;
		std::vector<sf::Sprite> _arc;
		unsigned _size;
		sf::Time _elapsedTime;
};

